Zoom Factor
The zoom factor is a number value that indicates the zoom factor for the timescale. To change it, call the zoom functions of the timescale.
Zoom In/Out
You can zoom in/out on the timescale:
Zoom Auto
You can also zoom the timescale to a suitable factor according to the labels of ticks on each tiers automatically.
Zoom To
You can zoom in or out on the timescale to a specific factor.
The following code zooms the timescale to display the target date range in the viewport. Note that the timescale will adjust to the nearest ticks.
Adjust Tier Unit
A boolean value indicates whether to adjust the units of tiers to a suitable value according to the zoom factor or not. This is true by default in the API:
timescale.zoomIn(adjustTierUnit);
timescale.zoomOut(adjustTierUnit);
timescale.zoomTo(zoomFactor, adjustTierUnit);
timescale.zoomToRange(startDate, endDate, adjustTierUnit);
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
var myTable;
var ganttSheet;
var adjustTierUnit = true;
window.onload = function() {
var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 0 });
initSpread(spread);
initSplitView(spread);
};
function initSpread(spread) {
spread.suspendPaint();
initDataSource(spread);
initGanttSheet(spread);
spread.resumePaint();
}
function initDataSource(spread) {
var tableName = "Gantt_Id";
var baseApiUrl = getBaseApiUrl();
var apiUrl = baseApiUrl + "/" + tableName;
var dataManager = spread.dataManager();
myTable = dataManager.addTable("myTable", {
batch: true,
remote: {
read: {
url: apiUrl
}
},
schema: {
hierarchy: {
type: "Parent",
column: "parentId"
},
columns: {
id: { isPrimaryKey: true },
taskNumber: { dataType: "rowOrder" }
}
}
});
}
function initGanttSheet(spread) {
ganttSheet = spread.addSheetTab(0, "GanttSheet", GC.Spread.Sheets.SheetType.ganttSheet);
var view = myTable.addView("ganttView", [
{ value: "taskNumber", caption: "NO.", width: 60 },
{ value: "name", caption: "Task Name", width: 200 },
{ value: "duration", caption: "Duration", width: 90 },
{ value: "predecessors", caption: "Predecessors", width: 120 }
]);
view.fetch().then(function() {
ganttSheet.bindGanttView(view);
}).then(function() {
ganttSheet.project.timescale.zoomOut();
});
initSidePanel(ganttSheet);
}
function initSidePanel(ganttSheet) {
var adjustTierUnitCheckbox = document.getElementById("adjust-tier-unit");
var zoomAutoButton = document.getElementById("zoom-auto");
var zoomInButton = document.getElementById("zoom-in");
var zoomOutButton = document.getElementById("zoom-out");
var zoomFactorInput = document.getElementById("zoom-factor");
var zoomToButton = document.getElementById("zoom-to");
var zoomToTypeSelect = document.getElementById("zoom-to-type");
var zoomToRangeButton = document.getElementById("zoom-to-range");
adjustTierUnitCheckbox.addEventListener("click", function() {
if (adjustTierUnitCheckbox.classList.contains("active")) {
adjustTierUnitCheckbox.classList.remove("active");
adjustTierUnit = false;
} else {
adjustTierUnitCheckbox.classList.add("active");
adjustTierUnit = true;
}
});
zoomAutoButton.addEventListener("click", function() {
ganttSheet.project.timescale.zoomAuto();
syncPanel(ganttSheet);
});
zoomInButton.addEventListener("click", function() {
ganttSheet.project.timescale.zoomIn(adjustTierUnit);
syncPanel(ganttSheet);
});
zoomOutButton.addEventListener("click", function() {
ganttSheet.project.timescale.zoomOut(adjustTierUnit);
syncPanel(ganttSheet);
});
zoomToButton.addEventListener("click", function() {
var factor = Number(zoomFactorInput.value);
if (!isNaN(factor)) {
ganttSheet.project.timescale.zoomTo(factor, adjustTierUnit);
syncPanel(ganttSheet);
}
});
zoomToRangeButton.addEventListener("click", function() {
var zoomToType = zoomToTypeSelect.value;
var project = ganttSheet.project;
if (zoomToType === "0") {
var task = ganttSheet.getActiveTask();
if(task && task.finish && task.start) {
project.timescale.zoomToRange(task.start, task.finish);
}
} else if (zoomToType === "1") {
var startDate = Math.min.apply(null, project.tasks.filter(function(t) {return t.start}).map(function(t) {return t.start.valueOf()}));
var finishDate = Math.max.apply(null, project.tasks.filter(function(t) {return t.finish}).map(function(t) {return t.finish.valueOf()}));
project.timescale.zoomToRange(new Date(startDate), new Date(finishDate));
} else if (zoomToType === "2") {
let count = Number(zoomToRangeCountInput.value);
let unit = Number(zoomToRangeUnitSelect.value);
let start = project.timescale.currentDate;
let defaultMilliseconds = [
365 * 24 * 60 * 60 * 1000, // Years= 0,
365 / 2 * 24 * 60 * 60 * 1000, // HalfYears= 1,
365 / 4 * 24 * 60 * 60 * 1000, // Quarters= 2,
30 * 24 * 60 * 60 * 1000, // Months= 3,
10 * 24 * 60 * 60 * 1000, // ThirdsOfMonth= 4,
7 * 24 * 60 * 60 * 1000, // Weeks= 5,
24 * 60 * 60 * 1000, // Days= 6,
60 * 60 * 1000, // Hours= 7,
60 * 1000, // Minutes= 8
];
let finish = new Date(start.valueOf() + defaultMilliseconds[unit] * count);
project.timescale.zoomToRange(start, finish);
}
syncPanel(ganttSheet);
});
}
function syncPanel(ganttSheet) {
var zoomFactorInput = document.getElementById("zoom-factor");
zoomFactorInput.value = ganttSheet.project.timescale.zoomFactor;
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
function initSplitView(spread) {
var host = document.getElementById("split-view");
var content = host.getElementsByClassName("split-content")[0];
var panel = host.getElementsByClassName("split-panel")[0];
new SplitView({
host: host,
content: content,
panel: panel,
refreshContent: function() {
spread.refresh();
}
});
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/spread/source/splitView/splitView.css">
<!-- Promise Polyfill for IE, https://www.npmjs.com/package/promise-polyfill -->
<script src="https://cdn.jsdelivr.net/npm/promise-polyfill@8/dist/polyfill.min.js"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-tablesheet/dist/gc.spread.sheets.tablesheet.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-ganttsheet/dist/gc.spread.sheets.ganttsheet.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/splitView/splitView.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div id="split-view" class="sample-tutorial">
<div id="ss" class="sample-spreadsheets split-content"></div>
<div class="options-container split-panel">
<div class="option-row option-title">
Zoom the ganttsheet chart area.
</div>
<div class="option-block">
<div class="option-row">
<label class="option-checkbox active" id="adjust-tier-unit">Adjust Tier Unit</label>
<div class="option-info">* checkbox toggle whether adjust tier unit or not when zoom. It affects the result of zoom in, zoom out, zoom to and zoom to range.</div>
</div>
</div>
<div class="option-block">
<div class="option-row">
<input type="button" id="zoom-auto" class="option-button" value="Zoom Auto" />
</div>
<div class="option-row">
<input type="button" id="zoom-in" class="option-button" value="Zoom In" />
</div>
<div class="option-row">
<input type="button" id="zoom-out" class="option-button" value="Zoom Out" />
</div>
</div>
<div class="option-block">
<div class="option-row input-box">
<label for="zoom-factor">Zoom Factor</label>
<input type="text" id="zoom-factor" value="1" />
<div class="option-info valid">* valid value: number</div>
</div>
<div class="option-row">
<input type="button" id="zoom-to" class="option-button" value="Zoom To" />
</div>
<div class="option-row selection-box">
<label for="zoom-to-type">Demo Range</label>
<select id="zoom-to-type">
<option value="0">Selected Task</option>
<option value="1">Entire Project</option>
</select>
</div>
<div class="option-row">
<input type="button" id="zoom-to-range" class="option-button" value="Zoom To Range" />
</div>
</div>
</div>
</div>
</html>
.option-block {
background: #fff;
padding: 8px;
margin: 12px 0;
border-radius: 4px;
border: 1px dashed #82bc00;
box-shadow: 0px 0 6px 0 rgba(0,0,0,0.1);
}
.option-block.toggle {
border: 1px dotted #f7a711;
}
.option-row {
font-size: 14px;
box-sizing: border-box;
padding: 4px 0;
}
.option-title {
font-weight: bold;
color: #656565;
}
.option-info {
font-size: 12px;
color: #919191;
margin-top: 6px;
font-weight: normal;
}
.option-info.valid {
color: #82bc00;
}
.option-info.toggle {
color: #f7a711;
}
.option-button {
width: 100%;
padding: 0;
line-height: 20px;
background: #82bc00;
color: #fff;
transition: 0.3s;
cursor: pointer;
outline: none;
border-radius: 4px;
box-sizing: border-box;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
border: none;
}
.option-button:hover {
background: #82bc00;
color: #fff;
box-shadow: 0 3px 8px 0 rgba(0,0,0,0.4);
}
.option-checkbox {
background: #fff;
border: 1px dashed #f7a711;
color: #f7a711;
padding: 2px 4px;
transition: 0.3s;
box-sizing: border-box;
cursor: pointer;
}
.option-checkbox.active {
color: #fff;
background: #f7a711;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
border-radius: 4px;
}
.selection-box {
position: relative;
}
.selection-box > select {
text-align: left;
width: 100%;
height: 20px;
padding: 0;
line-height: 20px;
background: transparent;
border: none;
border-bottom: 2px solid #656565;
color: #656565;
transition: 0.3s;
cursor: pointer;
outline: none;
box-sizing: border-box;
}
.selection-box > select > option {
background: white;
}
.selection-box > select:focus {
border-bottom: 2px solid #82bc00;
color: #82bc00;
box-shadow: 0 2px 6px 0 rgba(0,0,0,0.3);
}
.selection-box > label {
position: absolute;
cursor: pointer;
font-size: 12px;
color: #fff;
background: #656565;
padding: 0 4px;
right: 0;
top: 6px;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
}
.input-box {
position: relative;
}
.input-box > input[type=text] {
width: 100%;
background: transparent;
border: none;
color: #656565;
border-bottom: 2px solid #656565;
outline: none;
box-sizing: border-box;
transition: 0.3s;
}
.input-box > input[type=text]:focus {
color: #82bc00;
border-bottom: 2px solid #82bc00;
}
.input-box > label {
cursor: pointer;
position: absolute;
right: 0;
top: 5px;
font-size: 12px;
color: #fff;
background: #656565;
padding: 0 4px;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
}

Zoom Factor
The zoom factor is a number value that indicates the zoom factor for the timescale. To change it, call the zoom functions of the timescale.
Zoom In/Out
You can zoom in/out on the timescale:
Zoom Auto
You can also zoom the timescale to a suitable factor according to the labels of ticks on each tiers automatically.
Zoom To
You can zoom in or out on the timescale to a specific factor.
The following code zooms the timescale to display the target date range in the viewport. Note that the timescale will adjust to the nearest ticks.
Adjust Tier Unit
A boolean value indicates whether to adjust the units of tiers to a suitable value according to the zoom factor or not. This is true by default in the API:
timescale.zoomIn(adjustTierUnit);
timescale.zoomOut(adjustTierUnit);
timescale.zoomTo(zoomFactor, adjustTierUnit);
timescale.zoomToRange(startDate, endDate, adjustTierUnit);
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { FormsModule } from '@angular/forms';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import "@mescius/spread-sheets-ganttsheet";
import './styles.css';
declare let SplitView: any;
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
ganttSheet: GC.Spread.Sheets.GanttSheet;
myTable: any;
adjustTierUnit = true;
zoomFactor = "1";
zoomToType = "0";
hostStyle = {
width: '100%',
height: '100%'
};
initSpread($event: any) {
this.spread = $event.spread;
let spread = this.spread;
spread.suspendPaint();
spread.clearSheets();
this.initDataSource(spread);
this.initGanttSheet(spread);
spread.resumePaint();
initSplitView(spread);
}
initDataSource(spread: GC.Spread.Sheets.Workbook) {
let tableName = "Gantt_Id";
let baseApiUrl = getBaseApiUrl();
let apiUrl = baseApiUrl + "/" + tableName;
let dataManager = spread.dataManager();
this.myTable = dataManager.addTable("myTable", {
batch: true,
remote: {
read: {
url: apiUrl
}
},
schema: {
hierarchy: {
type: "Parent",
column: "parentId"
},
columns: {
id: { isPrimaryKey: true },
taskNumber: { dataType: "rowOrder" }
}
}
});
}
initGanttSheet(spread: GC.Spread.Sheets.Workbook) {
let ganttSheet = spread.addSheetTab(0, "GanttSheet", GC.Spread.Sheets.SheetType.ganttSheet);
this.ganttSheet = ganttSheet;
let view = this.myTable.addView("ganttView", [
{ value: "taskNumber", caption: "NO.", width: 60 },
{ value: "name", caption: "Task Name", width: 200 },
{ value: "duration", caption: "Duration", width: 90 },
{ value: "predecessors", caption: "Predecessors", width: 120 }
]);
view.fetch().then(function() {
ganttSheet.bindGanttView(view);
}).then(function() {
ganttSheet.project.timescale.zoomOut();
});
}
tierUnit() {
this.adjustTierUnit = !this.adjustTierUnit;
}
zoomAuto() {
this.ganttSheet.project.timescale.zoomAuto();
syncPanel(this.ganttSheet);
}
zoomIn() {
this.ganttSheet.project.timescale.zoomIn(this.adjustTierUnit);
syncPanel(this.ganttSheet);
}
zoomOut() {
this.ganttSheet.project.timescale.zoomOut(this.adjustTierUnit);
syncPanel(this.ganttSheet);
}
zoomTo() {
let factor = Number(this.zoomFactor);
if (!isNaN(factor)) {
this.ganttSheet.project.timescale.zoomTo(factor, this.adjustTierUnit);
syncPanel(this.ganttSheet);
}
}
zoomToRange() {
let zoomToType = this.zoomToType;
let project = this.ganttSheet.project;
if (zoomToType === "0") {
let task = this.ganttSheet.getActiveTask();
if (task && task.finish && task.start) {
project.timescale.zoomToRange(task.start, task.finish);
}
} else if (zoomToType === "1") {
let startDate = Math.min.apply(null, project.tasks.filter(function(t: any) { return t.start }).map(function(t: any) { return t.start.valueOf() }));
let finishDate = Math.max.apply(null, project.tasks.filter(function(t: any) { return t.finish }).map(function(t: any) { return t.finish.valueOf() }));
project.timescale.zoomToRange(new Date(startDate), new Date(finishDate));
}
syncPanel(this.ganttSheet);
}
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
function syncPanel(ganttSheet: GC.Spread.Sheets.GanttSheet) {
let zoomFactorInput = document.getElementById("zoom-factor");
zoomFactorInput.value = ganttSheet.project.timescale.zoomFactor;
}
function initSplitView(spread: any) {
let host = document.getElementById("split-view");
let content = host.getElementsByClassName("split-content")[0];
let panel = host.getElementsByClassName("split-panel")[0];
new SplitView({
host: host,
content: content,
panel: panel,
refreshContent: function() {
spread.refresh();
}
});
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/spread/source/splitView/splitView.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<!-- plugins -->
<script src="$DEMOROOT$/spread/source/splitView/SplitView.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div id="split-view" class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets split-content" [hostStyle]="hostStyle"
(workbookInitialized)="initSpread($event)">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container split-panel">
<div class="option-row option-title">
Zoom the ganttsheet chart area.
</div>
<div class="option-block">
<div class="option-row">
<label class="option-checkbox active" id="adjust-tier-unit" [ngClass]="{'active': adjustTierUnit}"
(click)="tierUnit()">Adjust Tier Unit</label>
<div class="option-info">* checkbox toggle whether adjust tier unit or not when zoom. It affects the
result of zoom in, zoom out, zoom to and zoom to range.</div>
</div>
</div>
<div class="option-block">
<div class="option-row">
<input type="button" id="zoom-auto" class="option-button" value="Zoom Auto" (click)="zoomAuto()" />
</div>
<div class="option-row">
<input type="button" id="zoom-in" class="option-button" value="Zoom In" (click)="zoomIn()" />
</div>
<div class="option-row">
<input type="button" id="zoom-out" class="option-button" value="Zoom Out" (click)="zoomOut()" />
</div>
</div>
<div class="option-block">
<div class="option-row input-box">
<label for="zoom-factor">Zoom Factor</label>
<input type="text" id="zoom-factor" [(ngModel)]="zoomFactor"/>
<div class="option-info valid">* valid value: number</div>
</div>
<div class="option-row">
<input type="button" id="zoom-to" class="option-button" value="Zoom To" (click)="zoomTo()" />
</div>
<div class="option-row selection-box">
<label for="zoom-to-type">Demo Range</label>
<select id="zoom-to-type" [(ngModel)]="zoomToType">
<option value="0">Selected Task</option>
<option value="1">Entire Project</option>
</select>
</div>
<div class="option-row">
<input type="button" id="zoom-to-range" class="option-button" value="Zoom To Range" (click)="zoomToRange()" />
</div>
</div>
</div>
</div>
.option-block {
background: #fff;
padding: 8px;
margin: 12px 0;
border-radius: 4px;
border: 1px dashed #82bc00;
box-shadow: 0px 0 6px 0 rgba(0,0,0,0.1);
}
.option-block.toggle {
border: 1px dotted #f7a711;
}
.option-row {
font-size: 14px;
box-sizing: border-box;
padding: 4px 0;
}
.option-title {
font-weight: bold;
color: #656565;
}
.option-info {
font-size: 12px;
color: #919191;
margin-top: 6px;
font-weight: normal;
}
.option-info.valid {
color: #82bc00;
}
.option-info.toggle {
color: #f7a711;
}
.option-button {
width: 100%;
padding: 0;
line-height: 20px;
background: #82bc00;
color: #fff;
transition: 0.3s;
cursor: pointer;
outline: none;
border-radius: 4px;
box-sizing: border-box;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
border: none;
}
.option-button:hover {
background: #82bc00;
color: #fff;
box-shadow: 0 3px 8px 0 rgba(0,0,0,0.4);
}
.option-checkbox {
background: #fff;
border: 1px dashed #f7a711;
color: #f7a711;
padding: 2px 4px;
transition: 0.3s;
box-sizing: border-box;
cursor: pointer;
}
.option-checkbox.active {
color: #fff;
background: #f7a711;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
border-radius: 4px;
}
.selection-box {
position: relative;
}
.selection-box > select {
text-align: left;
width: 100%;
height: 20px;
padding: 0;
line-height: 20px;
background: transparent;
border: none;
border-bottom: 2px solid #656565;
color: #656565;
transition: 0.3s;
cursor: pointer;
outline: none;
box-sizing: border-box;
}
.selection-box > select > option {
background: white;
}
.selection-box > select:focus {
border-bottom: 2px solid #82bc00;
color: #82bc00;
box-shadow: 0 2px 6px 0 rgba(0,0,0,0.3);
}
.selection-box > label {
position: absolute;
cursor: pointer;
font-size: 12px;
color: #fff;
background: #656565;
padding: 0 4px;
right: 0;
top: 6px;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
}
.input-box {
position: relative;
}
.input-box > input[type=text] {
width: 100%;
background: transparent;
border: none;
color: #656565;
border-bottom: 2px solid #656565;
outline: none;
box-sizing: border-box;
transition: 0.3s;
}
.input-box > input[type=text]:focus {
color: #82bc00;
border-bottom: 2px solid #82bc00;
}
.input-box > label {
cursor: pointer;
position: absolute;
right: 0;
top: 5px;
font-size: 12px;
color: #fff;
background: #656565;
padding: 0 4px;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-ganttsheet': 'npm:@mescius/spread-sheets-ganttsheet/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

Zoom Factor
The zoom factor is a number value that indicates the zoom factor for the timescale. To change it, call the zoom functions of the timescale.
Zoom In/Out
You can zoom in/out on the timescale:
Zoom Auto
You can also zoom the timescale to a suitable factor according to the labels of ticks on each tiers automatically.
Zoom To
You can zoom in or out on the timescale to a specific factor.
The following code zooms the timescale to display the target date range in the viewport. Note that the timescale will adjust to the nearest ticks.
Adjust Tier Unit
A boolean value indicates whether to adjust the units of tiers to a suitable value according to the zoom factor or not. This is true by default in the API:
timescale.zoomIn(adjustTierUnit);
timescale.zoomOut(adjustTierUnit);
timescale.zoomTo(zoomFactor, adjustTierUnit);
timescale.zoomToRange(startDate, endDate, adjustTierUnit);
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import "@mescius/spread-sheets-ganttsheet";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
const useState = React.useState;
let ganttSheet = null;
let myTable = null;
export function AppFunc() {
const [state, setState] = useState({
zoomFactor: 1,
zoomToType: "0",
adjustTierUnit: true
});
const initSpread = (spread) => {
spread.suspendPaint();
spread.clearSheets();
initDataSource(spread);
initGanttSheet(spread);
spread.resumePaint();
initSplitView(spread);
}
const initDataSource = (spread) => {
let tableName = "Gantt_Id";
let baseApiUrl = getBaseApiUrl();
let apiUrl = baseApiUrl + "/" + tableName;
let dataManager = spread.dataManager();
myTable = dataManager.addTable("myTable", {
batch: true,
remote: {
read: {
url: apiUrl
}
},
schema: {
hierarchy: {
type: "Parent",
column: "parentId"
},
columns: {
id: { isPrimaryKey: true },
taskNumber: { dataType: "rowOrder" }
}
}
});
}
const initGanttSheet = (spread) => {
ganttSheet = spread.addSheetTab(0, "GanttSheet", GC.Spread.Sheets.SheetType.ganttSheet);
let view = myTable.addView("ganttView", [
{ value: "taskNumber", caption: "NO.", width: 60 },
{ value: "name", caption: "Task Name", width: 200 },
{ value: "duration", caption: "Duration", width: 90 },
{ value: "predecessors", caption: "Predecessors", width: 120 }
]);
view.fetch().then(function () {
ganttSheet.bindGanttView(view);
}).then(function () {
ganttSheet.project.timescale.zoomOut();
});
// initSidePanel(ganttSheet);
}
const tierUnit = () => {
let adjustTierUnitCheckbox = document.getElementById("adjust-tier-unit");
if (adjustTierUnitCheckbox.classList.contains("active")) {
adjustTierUnitCheckbox.classList.remove("active");
setState({ ...state, adjustTierUnit: false });
} else {
adjustTierUnitCheckbox.classList.add("active");
setState({ ...state, adjustTierUnit: true });
}
}
const zoomAuto = () => {
ganttSheet.project.timescale.zoomAuto();
syncPanel(ganttSheet);
}
const zoomIn = () => {
ganttSheet.project.timescale.zoomIn(state.adjustTierUnit);
syncPanel(ganttSheet);
}
const zoomOut = () => {
ganttSheet.project.timescale.zoomOut(state.adjustTierUnit);
syncPanel(ganttSheet);
}
const zoomTo = () => {
let factor = Number(state.zoomFactor);
if (!isNaN(factor)) {
ganttSheet.project.timescale.zoomTo(factor, state.adjustTierUnit);
syncPanel(ganttSheet);
}
}
const zoomToRange = () => {
let zoomToType = state.zoomToType;
let project = ganttSheet.project;
if (zoomToType === "0") {
let task = ganttSheet.getActiveTask();
if (task && task.finish && task.start) {
project.timescale.zoomToRange(task.start, task.finish);
}
} else if (zoomToType === "1") {
let startDate = Math.min.apply(null, project.tasks.filter(function (t) { return t.start }).map(function (t) { return t.start.valueOf() }));
let finishDate = Math.max.apply(null, project.tasks.filter(function (t) { return t.finish }).map(function (t) { return t.finish.valueOf() }));
project.timescale.zoomToRange(new Date(startDate), new Date(finishDate));
}
syncPanel(ganttSheet);
}
const syncPanel = (ganttSheet) => {
let zoomFactorInput = document.getElementById("zoom-factor");
zoomFactorInput.value = ganttSheet.project.timescale.zoomFactor;
}
return (
<div id="split-view" class="sample-tutorial">
<div id="ss" class="sample-spreadsheets split-content">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}></SpreadSheets>
</div>
<div class="options-container split-panel">
<div class="option-row option-title">
Zoom the ganttsheet chart area.
</div>
<div class="option-block">
<div class="option-row">
<label class="option-checkbox active" id="adjust-tier-unit" onClick={() => { tierUnit() }}>Adjust Tier Unit</label>
<div class="option-info">* checkbox toggle whether adjust tier unit or not when zoom. It affects the result of zoom in, zoom out, zoom to and zoom to range.</div>
</div>
</div>
<div class="option-block">
<div class="option-row">
<input type="button" id="zoom-auto" class="option-button" value="Zoom Auto" onClick={() => { zoomAuto(state) }} />
</div>
<div class="option-row">
<input type="button" id="zoom-in" class="option-button" value="Zoom In" onClick={() => { zoomIn(state) }} />
</div>
<div class="option-row">
<input type="button" id="zoom-out" class="option-button" value="Zoom Out" onClick={() => { zoomOut(state) }} />
</div>
</div>
<div class="option-block">
<div class="option-row input-box">
<label for="zoom-factor">Zoom Factor</label>
<input type="text" id="zoom-factor" value={state.zoomFactor} onChange={(e) => { setState({ ...state, zoomFactor: e.target.value }) }} />
<div class="option-info valid">* valid value: number</div>
</div>
<div class="option-row">
<input type="button" id="zoom-to" class="option-button" value="Zoom To" onClick={() => { zoomTo(state) }} />
</div>
<div class="option-row selection-box">
<label for="zoom-to-type">Demo Range</label>
<select id="zoom-to-type" value={state.zoomToType} onChange={(e) => { setState({ ...state, zoomToType: e.target.value }) }}>
<option value="0">Selected Task</option>
<option value="1">Entire Project</option>
</select>
</div>
<div class="option-row">
<input type="button" id="zoom-to-range" class="option-button" value="Zoom To Range" onClick={() => { zoomToRange(state) }} />
</div>
</div>
</div>
</div>
);
}
function initSplitView(spread) {
let host = document.getElementById("split-view");
let content = host.getElementsByClassName("split-content")[0];
let panel = host.getElementsByClassName("split-panel")[0];
new SplitView({
host: host,
content: content,
panel: panel,
refreshContent: function () {
spread.refresh();
}
});
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import "@mescius/spread-sheets-ganttsheet";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.ganttSheet = null;
this.state = {
zoomFactor: 1,
zoomToType: "0",
adjustTierUnit: true
};
}
render() {
return (
<div id="split-view" class="sample-tutorial">
<div id="ss" class="sample-spreadsheets split-content">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}></SpreadSheets>
</div>
<div class="options-container split-panel">
<div class="option-row option-title">
Zoom the ganttsheet chart area.
</div>
<div class="option-block">
<div class="option-row">
<label class="option-checkbox active" id="adjust-tier-unit" onClick={() => { this.tierUnit() }}>Adjust Tier Unit</label>
<div class="option-info">* checkbox toggle whether adjust tier unit or not when zoom. It affects the result of zoom in, zoom out, zoom to and zoom to range.</div>
</div>
</div>
<div class="option-block">
<div class="option-row">
<input type="button" id="zoom-auto" class="option-button" value="Zoom Auto" onClick={() => { this.zoomAuto(this.state) }} />
</div>
<div class="option-row">
<input type="button" id="zoom-in" class="option-button" value="Zoom In" onClick={() => { this.zoomIn(this.state) }} />
</div>
<div class="option-row">
<input type="button" id="zoom-out" class="option-button" value="Zoom Out" onClick={() => { this.zoomOut(this.state) }} />
</div>
</div>
<div class="option-block">
<div class="option-row input-box">
<label for="zoom-factor">Zoom Factor</label>
<input type="text" id="zoom-factor" value={this.state.zoomFactor} onChange={(e) => { this.setState({ zoomFactor: e.target.value }) }} />
<div class="option-info valid">* valid value: number</div>
</div>
<div class="option-row">
<input type="button" id="zoom-to" class="option-button" value="Zoom To" onClick={() => { this.zoomTo(this.state) }} />
</div>
<div class="option-row selection-box">
<label for="zoom-to-type">Demo Range</label>
<select id="zoom-to-type" value={this.state.zoomToType} onChange={(e) => { this.setState({ zoomToType: e.target.value }) }}>
<option value="0">Selected Task</option>
<option value="1">Entire Project</option>
</select>
</div>
<div class="option-row">
<input type="button" id="zoom-to-range" class="option-button" value="Zoom To Range" onClick={() => { this.zoomToRange(this.state) }} />
</div>
</div>
</div>
</div>
);
}
initSpread(spread) {
this.spread = spread;
spread.suspendPaint();
spread.clearSheets();
this.initDataSource(spread);
this.initGanttSheet(spread);
spread.resumePaint();
initSplitView(spread);
}
initDataSource(spread) {
let tableName = "Gantt_Id";
let baseApiUrl = getBaseApiUrl();
let apiUrl = baseApiUrl + "/" + tableName;
let dataManager = spread.dataManager();
let myTable = dataManager.addTable("myTable", {
batch: true,
remote: {
read: {
url: apiUrl
}
},
schema: {
hierarchy: {
type: "Parent",
column: "parentId"
},
columns: {
id: { isPrimaryKey: true },
taskNumber: { dataType: "rowOrder" }
}
}
});
this.myTable = myTable;
}
initGanttSheet(spread) {
let ganttSheet = spread.addSheetTab(0, "GanttSheet", GC.Spread.Sheets.SheetType.ganttSheet);
this.ganttSheet = ganttSheet;
let view = this.myTable.addView("ganttView", [
{ value: "taskNumber", caption: "NO.", width: 60 },
{ value: "name", caption: "Task Name", width: 200 },
{ value: "duration", caption: "Duration", width: 90 },
{ value: "predecessors", caption: "Predecessors", width: 120 }
]);
view.fetch().then(function () {
ganttSheet.bindGanttView(view);
}).then(function () {
ganttSheet.project.timescale.zoomOut();
});
// initSidePanel(ganttSheet);
}
tierUnit() {
let adjustTierUnitCheckbox = document.getElementById("adjust-tier-unit");
if (adjustTierUnitCheckbox.classList.contains("active")) {
adjustTierUnitCheckbox.classList.remove("active");
this.setState({ adjustTierUnit: false });
} else {
adjustTierUnitCheckbox.classList.add("active");
this.setState({ adjustTierUnit: true });
}
}
zoomAuto() {
this.ganttSheet.project.timescale.zoomAuto();
this.syncPanel(this.ganttSheet);
}
zoomIn() {
this.ganttSheet.project.timescale.zoomIn(this.state.adjustTierUnit);
this.syncPanel(this.ganttSheet);
}
zoomOut() {
this.ganttSheet.project.timescale.zoomOut(this.state.adjustTierUnit);
this.syncPanel(this.ganttSheet);
}
zoomTo() {
let factor = Number(this.state.zoomFactor);
if (!isNaN(factor)) {
this.ganttSheet.project.timescale.zoomTo(factor, this.state.adjustTierUnit);
this.syncPanel(this.ganttSheet);
}
}
zoomToRange() {
let zoomToType = this.state.zoomToType;
let project = this.ganttSheet.project;
if (zoomToType === "0") {
let task = this.ganttSheet.getActiveTask();
if (task && task.finish && task.start) {
project.timescale.zoomToRange(task.start, task.finish);
}
} else if (zoomToType === "1") {
let startDate = Math.min.apply(null, project.tasks.filter(function (t) { return t.start }).map(function (t) { return t.start.valueOf() }));
let finishDate = Math.max.apply(null, project.tasks.filter(function (t) { return t.finish }).map(function (t) { return t.finish.valueOf() }));
project.timescale.zoomToRange(new Date(startDate), new Date(finishDate));
}
this.syncPanel(this.ganttSheet);
}
syncPanel(ganttSheet) {
let zoomFactorInput = document.getElementById("zoom-factor");
zoomFactorInput.value = ganttSheet.project.timescale.zoomFactor;
}
}
function initSplitView(spread) {
let host = document.getElementById("split-view");
let content = host.getElementsByClassName("split-content")[0];
let panel = host.getElementsByClassName("split-panel")[0];
new SplitView({
host: host,
content: content,
panel: panel,
refreshContent: function () {
spread.refresh();
}
});
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/spread/source/splitView/splitView.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="$DEMOROOT$/spread/source/data/employees.js" type="text/javascript"></script>
<script src="systemjs.config.js"></script>
<!-- plugins -->
<script src="$DEMOROOT$/spread/source/splitView/SplitView.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.option-block {
background: #fff;
padding: 8px;
margin: 12px 0;
border-radius: 4px;
border: 1px dashed #82bc00;
box-shadow: 0px 0 6px 0 rgba(0,0,0,0.1);
}
.option-block.toggle {
border: 1px dotted #f7a711;
}
.option-row {
font-size: 14px;
box-sizing: border-box;
padding: 4px 0;
}
.option-title {
font-weight: bold;
color: #656565;
}
.option-info {
font-size: 12px;
color: #919191;
margin-top: 6px;
font-weight: normal;
}
.option-info.valid {
color: #82bc00;
}
.option-info.toggle {
color: #f7a711;
}
.option-button {
width: 100%;
padding: 0;
line-height: 20px;
background: #82bc00;
color: #fff;
transition: 0.3s;
cursor: pointer;
outline: none;
border-radius: 4px;
box-sizing: border-box;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
border: none;
}
.option-button:hover {
background: #82bc00;
color: #fff;
box-shadow: 0 3px 8px 0 rgba(0,0,0,0.4);
}
.option-checkbox {
background: #fff;
border: 1px dashed #f7a711;
color: #f7a711;
padding: 2px 4px;
transition: 0.3s;
box-sizing: border-box;
cursor: pointer;
}
.option-checkbox.active {
color: #fff;
background: #f7a711;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
border-radius: 4px;
}
.selection-box {
position: relative;
}
.selection-box > select {
text-align: left;
width: 100%;
height: 20px;
padding: 0;
line-height: 20px;
background: transparent;
border: none;
border-bottom: 2px solid #656565;
color: #656565;
transition: 0.3s;
cursor: pointer;
outline: none;
box-sizing: border-box;
}
.selection-box > select > option {
background: white;
}
.selection-box > select:focus {
border-bottom: 2px solid #82bc00;
color: #82bc00;
box-shadow: 0 2px 6px 0 rgba(0,0,0,0.3);
}
.selection-box > label {
position: absolute;
cursor: pointer;
font-size: 12px;
color: #fff;
background: #656565;
padding: 0 4px;
right: 0;
top: 6px;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
}
.input-box {
position: relative;
}
.input-box > input[type=text] {
width: 100%;
background: transparent;
border: none;
color: #656565;
border-bottom: 2px solid #656565;
outline: none;
box-sizing: border-box;
transition: 0.3s;
}
.input-box > input[type=text]:focus {
color: #82bc00;
border-bottom: 2px solid #82bc00;
}
.input-box > label {
cursor: pointer;
position: absolute;
right: 0;
top: 5px;
font-size: 12px;
color: #fff;
background: #656565;
padding: 0 4px;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-ganttsheet': 'npm:@mescius/spread-sheets-ganttsheet/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

Zoom Factor
The zoom factor is a number value that indicates the zoom factor for the timescale. To change it, call the zoom functions of the timescale.
Zoom In/Out
You can zoom in/out on the timescale:
Zoom Auto
You can also zoom the timescale to a suitable factor according to the labels of ticks on each tiers automatically.
Zoom To
You can zoom in or out on the timescale to a specific factor.
The following code zooms the timescale to display the target date range in the viewport. Note that the timescale will adjust to the nearest ticks.
Adjust Tier Unit
A boolean value indicates whether to adjust the units of tiers to a suitable value according to the zoom factor or not. This is true by default in the API:
timescale.zoomIn(adjustTierUnit);
timescale.zoomOut(adjustTierUnit);
timescale.zoomTo(zoomFactor, adjustTierUnit);
timescale.zoomToRange(startDate, endDate, adjustTierUnit);
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
<template>
<div id="split-view" class="sample-tutorial">
<gc-spread-sheets
class="sample-spreadsheets split-content"
@workbookInitialized="initSpread"
>
</gc-spread-sheets>
<div class="options-container split-panel">
<div class="option-row option-title">Zoom the ganttsheet chart area.</div>
<div class="option-block">
<div class="option-row">
<label
class="option-checkbox"
id="adjust-tier-unit"
v-bind:class="{ active: tierUnit }"
@click="changeTierUnit"
>Adjust Tier Unit</label
>
<div class="option-info">
* checkbox toggle whether adjust tier unit or not when zoom. It
affects the result of zoom in, zoom out, zoom to and zoom to range.
</div>
</div>
</div>
<div class="option-block">
<div class="option-row">
<input
type="button"
id="zoom-auto"
class="option-button"
value="Zoom Auto"
@click="zoomAuto($event)"
/>
</div>
<div class="option-row">
<input
type="button"
id="zoom-in"
class="option-button"
value="Zoom In"
@click="zoomIn($event)"
/>
</div>
<div class="option-row">
<input
type="button"
id="zoom-out"
class="option-button"
value="Zoom Out"
@click="zoomOut($event)"
/>
</div>
</div>
<div class="option-block">
<div class="option-row input-box">
<label for="zoom-factor">Zoom Factor</label>
<input type="text" id="zoom-factor" v-model="zoomFactor" />
<div class="option-info valid">* valid value: number</div>
</div>
<div class="option-row">
<input
type="button"
id="zoom-to"
class="option-button"
value="Zoom To"
@click="zoomTo($event)"
/>
</div>
<div class="option-row selection-box">
<label for="zoom-to-type">Demo Range</label>
<select id="zoom-to-type" v-model="zoomToType">
<option value="0">Selected Task</option>
<option value="1">Entire Project</option>
</select>
</div>
<div class="option-row">
<input
type="button"
id="zoom-to-range"
class="option-button"
value="Zoom To Range"
@click="zoomToRange($event)"
/>
</div>
</div>
</div>
</div>
</template>
<script>
import Vue from "vue";
import "@mescius/spread-sheets-vue";
import GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-tablesheet";
import "@mescius/spread-sheets-ganttsheet";
import "./styles.css";
let App = Vue.extend({
name: "app",
myTable: null,
ganttSheet: null,
data: function () {
return {
spread: null,
tierUnit: true,
zoomFactor: "1",
zoomToType: "0",
};
},
methods: {
initSpread: function (spread) {
this.spread = spread;
spread.suspendPaint();
spread.clearSheets();
this.initDataSource(spread);
this.initGanttSheet(spread);
spread.resumePaint();
initSplitView(spread);
},
initDataSource(spread) {
var tableName = "Gantt_Id";
var baseApiUrl = getBaseApiUrl();
var apiUrl = baseApiUrl + "/" + tableName;
var dataManager = spread.dataManager();
this.myTable = dataManager.addTable("myTable", {
batch: true,
remote: {
read: {
url: apiUrl,
},
},
schema: {
hierarchy: {
type: "Parent",
column: "parentId",
},
columns: {
id: { isPrimaryKey: true },
taskNumber: { dataType: "rowOrder" },
},
},
});
},
initGanttSheet(spread) {
let ganttSheet = spread.addSheetTab(
0,
"GanttSheet",
GC.Spread.Sheets.SheetType.ganttSheet
);
this.ganttSheet = ganttSheet;
var view = this.myTable.addView("ganttView", [
{ value: "taskNumber", caption: "NO.", width: 60 },
{ value: "name", caption: "Task Name", width: 200 },
{ value: "duration", caption: "Duration", width: 90 },
{ value: "predecessors", caption: "Predecessors", width: 120 },
]);
view
.fetch()
.then(function () {
ganttSheet.bindGanttView(view);
})
.then(function () {
ganttSheet.project.timescale.zoomOut();
});
},
changeTierUnit() {
this.tierUnit = !this.tierUnit;
},
zoomAuto() {
this.ganttSheet.project.timescale.zoomAuto();
this.syncPanel(this.ganttSheet);
},
zoomIn() {
this.ganttSheet.project.timescale.zoomIn(this.tierUnit);
this.syncPanel(this.ganttSheet);
},
zoomOut() {
this.ganttSheet.project.timescale.zoomOut(this.tierUnit);
this.syncPanel(this.ganttSheet);
},
zoomTo() {
let factor = Number(this.zoomFactor);
if (!isNaN(factor)) {
this.ganttSheet.project.timescale.zoomTo(factor, this.tierUnit);
this.syncPanel(this.ganttSheet);
}
},
zoomToRange() {
let zoomToType = this.zoomToType;
let project = this.ganttSheet.project;
if (zoomToType === "0") {
let task = this.ganttSheet.getActiveTask();
if (task && task.finish && task.start) {
project.timescale.zoomToRange(task.start, task.finish);
}
} else if (zoomToType === "1") {
let startDate = Math.min.apply(
null,
project.tasks
.filter(function (t) {
return t.start;
})
.map(function (t) {
return t.start.valueOf();
})
);
let finishDate = Math.max.apply(
null,
project.tasks
.filter(function (t) {
return t.finish;
})
.map(function (t) {
return t.finish.valueOf();
})
);
project.timescale.zoomToRange(
new Date(startDate),
new Date(finishDate)
);
}
this.syncPanel(this.ganttSheet);
},
syncPanel(ganttSheet) {
this.zoomFactor = ganttSheet.project.timescale.zoomFactor;
},
},
});
function initSplitView(spread) {
var host = document.getElementById("split-view");
var content = host.getElementsByClassName("split-content")[0];
var panel = host.getElementsByClassName("split-panel")[0];
new SplitView({
host: host,
content: content,
panel: panel,
refreshContent: function () {
spread.refresh();
},
});
}
function getBaseApiUrl() {
return (
window.location.href.match(/http.+spreadjs\/demos\//)[0] + "server/api"
);
}
new Vue({
render: (h) => h(App),
}).$mount("#app");
</script>
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/spread/source/splitView/splitView.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/vue/node_modules/systemjs/dist/system.src.js"></script>
<script src="$DEMOROOT$/spread/source/data/employees.js" type="text/javascript"></script>
<script src="systemjs.config.js"></script>
<!-- plugins -->
<script src="$DEMOROOT$/spread/source/splitView/SplitView.js"></script>
<script>
System.import('./src/app.vue');
System.import('$DEMOROOT$/en/lib/vue/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.option-block {
background: #fff;
padding: 8px;
margin: 12px 0;
border-radius: 4px;
border: 1px dashed #82bc00;
box-shadow: 0px 0 6px 0 rgba(0,0,0,0.1);
}
.option-block.toggle {
border: 1px dotted #f7a711;
}
.option-row {
font-size: 14px;
box-sizing: border-box;
padding: 4px 0;
}
.option-title {
font-weight: bold;
color: #656565;
}
.option-info {
font-size: 12px;
color: #919191;
margin-top: 6px;
font-weight: normal;
}
.option-info.valid {
color: #82bc00;
}
.option-info.toggle {
color: #f7a711;
}
.option-button {
width: 100%;
padding: 0;
line-height: 20px;
background: #82bc00;
color: #fff;
transition: 0.3s;
cursor: pointer;
outline: none;
border-radius: 4px;
box-sizing: border-box;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
border: none;
}
.option-button:hover {
background: #82bc00;
color: #fff;
box-shadow: 0 3px 8px 0 rgba(0,0,0,0.4);
}
.option-checkbox {
background: #fff;
border: 1px dashed #f7a711;
color: #f7a711;
padding: 2px 4px;
transition: 0.3s;
box-sizing: border-box;
cursor: pointer;
}
.option-checkbox.active {
color: #fff;
background: #f7a711;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
border-radius: 4px;
}
.selection-box {
position: relative;
}
.selection-box > select {
text-align: left;
width: 100%;
height: 20px;
padding: 0;
line-height: 20px;
background: transparent;
border: none;
border-bottom: 2px solid #656565;
color: #656565;
transition: 0.3s;
cursor: pointer;
outline: none;
box-sizing: border-box;
}
.selection-box > select > option {
background: white;
}
.selection-box > select:focus {
border-bottom: 2px solid #82bc00;
color: #82bc00;
box-shadow: 0 2px 6px 0 rgba(0,0,0,0.3);
}
.selection-box > label {
position: absolute;
cursor: pointer;
font-size: 12px;
color: #fff;
background: #656565;
padding: 0 4px;
right: 0;
top: 6px;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
}
.input-box {
position: relative;
}
.input-box > input[type=text] {
width: 100%;
background: transparent;
border: none;
color: #656565;
border-bottom: 2px solid #656565;
outline: none;
box-sizing: border-box;
transition: 0.3s;
}
.input-box > input[type=text]:focus {
color: #82bc00;
border-bottom: 2px solid #82bc00;
}
.input-box > label {
cursor: pointer;
position: absolute;
right: 0;
top: 5px;
font-size: 12px;
color: #fff;
background: #656565;
padding: 0 4px;
box-shadow: 0 1px 4px 0 rgba(0,0,0,0.3);
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: 'vue-loader' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-ganttsheet': 'npm:@mescius/spread-sheets-ganttsheet/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.min.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
}
}
});
})(this);